/*******************************  LICENSE  *******************************


 Copyright 2007 European Centre for Medium-Range Weather Forecasts (ECMWF)
 
 Licensed under the Apache License, Version 2.0 (the "License"); 
 you may not use this file except in compliance with the License. 
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing, software 
 distributed under the License is distributed on an "AS IS" BASIS, 
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 See the License for the specific language governing permissions and 
 limitations under the License.


 *******************************  LICENSE  *******************************/

/*! \file CoastlinesAttributes.h
    \brief Definition of Coastlines Attributes class.
    \author MeteoroMagLogical Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Tue Nov 22 10:53:37 2011
*/
   

#ifndef CoastlinesAttributes_H
#define CoastlinesAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "GridPlotting.h"
#include "LabelPlotting.h"
#include "CoastPlotting.h"

namespace magics {

class XmlNode;



class CoastlinesAttributes 
{
public:
//  --  constructor
    CoastlinesAttributes();
    
//  --  destructor
    virtual ~CoastlinesAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const CoastlinesAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

    void setXmlData(const string&)  {}
/*!
    Magics Information:
    \brief  
             Plot coastlines on map (ON/OFF)
           
    \param coastlines Setting map_coastline - default=on
*/
	void setCoastlines(NoCoastPlotting* coastlines) 
		{ auto_ptr<NoCoastPlotting> tmp(coastlines); coastlines_ = tmp; } 
	const NoCoastPlotting&  getCoastlines() const 
		{ return *coastlines_; }
/*!
    Magics Information:
    \brief 
            Plot grid lines on map (On/OFF)
           
    \param grid Setting map_grid - default=on
*/
	void setGrid(NoGridPlotting* grid) 
		{ auto_ptr<NoGridPlotting> tmp(grid); grid_ = tmp; } 
	const NoGridPlotting&  getGrid() const 
		{ return *grid_; }
/*!
    Magics Information:
    \brief 
            Plot label  on map grid lines (On/OFF)
           
    \param label Setting map_label - default=on
*/
	void setLabel(NoLabelPlotting* label) 
		{ auto_ptr<NoLabelPlotting> tmp(label); label_ = tmp; } 
	const NoLabelPlotting&  getLabel() const 
		{ return *label_; }
	virtual void toxml(ostream& out, int tabs = 0) const { toxml(out, tag_, tabs); }

protected:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream&, const string&, int tabs) const;

	//  --  members:
	string tag_;
	auto_ptr<NoCoastPlotting> coastlines_;
	auto_ptr<NoGridPlotting> grid_;
	auto_ptr<NoLabelPlotting> label_;

private:
  
	friend ostream& operator<<(ostream& s,const CoastlinesAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
