/*******************************  LICENSE  *******************************


 Copyright 2007 European Centre for Medium-Range Weather Forecasts (ECMWF)
 
 Licensed under the Apache License, Version 2.0 (the "License"); 
 you may not use this file except in compliance with the License. 
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing, software 
 distributed under the License is distributed on an "AS IS" BASIS, 
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 See the License for the specific language governing permissions and 
 limitations under the License.


 *******************************  LICENSE  *******************************/

/*! \file LandShadingAttributes.h
    \brief Definition of LandShading Attributes class.
    \author MeteoroMagLogical Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Tue Nov 22 10:53:37 2011
*/
   

#ifndef LandShadingAttributes_H
#define LandShadingAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"


#include "Colour.h"
#include "SeaShading.h"

namespace magics {

class XmlNode;



class LandShadingAttributes 
{
public:
//  --  constructor
    LandShadingAttributes();
    
//  --  destructor
    virtual ~LandShadingAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const LandShadingAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

    void setXmlData(const string&)  {}
/*!
    Magics Information:
    \brief Colour of Shading of land areas
    \param colour Setting map_coastline_land_shade_colour - default=green
*/
	void setColour(Colour* colour) 
		{ auto_ptr<Colour> tmp(colour); colour_ = tmp; } 
	const Colour&  getColour() const 
		{ return *colour_; }
/*!
    Magics Information:
    \brief Shade the sea areas
    \param sea Setting map_coastline_sea_shade - default=off
*/
	void setSea(NoSeaShading* sea) 
		{ auto_ptr<NoSeaShading> tmp(sea); sea_ = tmp; } 
	const NoSeaShading&  getSea() const 
		{ return *sea_; }
	virtual void toxml(ostream& out, int tabs = 0) const { toxml(out, tag_, tabs); }

protected:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream&, const string&, int tabs) const;

	//  --  members:
	string tag_;
	auto_ptr<Colour> colour_;
	auto_ptr<NoSeaShading> sea_;

private:
  
	friend ostream& operator<<(ostream& s,const LandShadingAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
