/*******************************  LICENSE  *******************************


 Copyright 2007 European Centre for Medium-Range Weather Forecasts (ECMWF)
 
 Licensed under the Apache License, Version 2.0 (the "License"); 
 you may not use this file except in compliance with the License. 
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing, software 
 distributed under the License is distributed on an "AS IS" BASIS, 
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 See the License for the specific language governing permissions and 
 limitations under the License.


 *******************************  LICENSE  *******************************/

/*! \file LevelListSelectionTypeAttributes.h
    \brief Definition of LevelListSelectionType Attributes class.
    \author MeteoroMagLogical Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Tue Nov 22 10:53:38 2011
*/
   

#ifndef LevelListSelectionTypeAttributes_H
#define LevelListSelectionTypeAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



namespace magics {

class XmlNode;



class LevelListSelectionTypeAttributes 
{
public:
//  --  constructor
    LevelListSelectionTypeAttributes();
    
//  --  destructor
    virtual ~LevelListSelectionTypeAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const LevelListSelectionTypeAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

    void setXmlData(const string&)  {}
/*!
    Magics Information:
    \brief  List of contour levels to be plotted 
    \param list Setting contour_level_list - default=floatarray()
*/
	void setList(floatarray list) 
		{ list_ =  list; } 
	floatarray getList() const 
		{ return list_; } 
        
	virtual void toxml(ostream& out, int tabs = 0) const { toxml(out, tag_, tabs); }

protected:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream&, const string&, int tabs) const;

	//  --  members:
	string tag_;
	floatarray list_;

private:
  
	friend ostream& operator<<(ostream& s,const LevelListSelectionTypeAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
