/*******************************  LICENSE  *******************************


 Copyright 2007 European Centre for Medium-Range Weather Forecasts (ECMWF)
 
 Licensed under the Apache License, Version 2.0 (the "License"); 
 you may not use this file except in compliance with the License. 
 You may obtain a copy of the License at 
 
 	http://www.apache.org/licenses/LICENSE-2.0
 
 Unless required by applicable law or agreed to in writing, software 
 distributed under the License is distributed on an "AS IS" BASIS, 
 WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 See the License for the specific language governing permissions and 
 limitations under the License.


 *******************************  LICENSE  *******************************/

/*! \file LookupTableModeAttributes.h
    \brief Definition of LookupTableMode Attributes class.
    \author MeteoroMagLogical Visualisation Section, ECMWF

    This file is automatically generated.
    Do Not Edit!

    Generated: Tue Nov 22 10:53:39 2011
*/
   

#ifndef LookupTableModeAttributes_H
#define LookupTableModeAttributes_H

#include "magics.h"
#include "ParameterManager.h"
#include "Factory.h"



namespace magics {

class XmlNode;



class LookupTableModeAttributes 
{
public:
//  --  constructor
    LookupTableModeAttributes();
    
//  --  destructor
    virtual ~LookupTableModeAttributes();
    
    virtual void set(const std::map<string, string>&);
    virtual void set(const XmlNode&);
    virtual void copy(const LookupTableModeAttributes&);
    virtual bool accept(const string&);

    void setTag(const string& tag) { tag_ = tag; }

    void setXmlData(const string&)  {}
/*!
    Magics Information:
    \brief  The lowest pixel value to be plotted  
    \param minlevel Setting image_min_level - default=-1.0e+21
*/
	void setMinLevel(int minlevel) 
		{ minLevel_ =  minlevel; } 
	int getMinLevel() const 
		{ return minLevel_; } 
        
/*!
    Magics Information:
    \brief  The highest pixel value to be plotted  
    \param maxlevel Setting image_max_level - default=1.0e+21
*/
	void setMaxLevel(int maxlevel) 
		{ maxLevel_ =  maxlevel; } 
	int getMaxLevel() const 
		{ return maxLevel_; } 
        
/*!
    Magics Information:
    \brief  The outlayer rejection factor 
    \param outlayer Setting image_outlayer_rejection - default=0
*/
	void setOutlayer(double outlayer) 
		{ outlayer_ =  outlayer; } 
	double getOutlayer() const 
		{ return outlayer_; } 
        
	virtual void toxml(ostream& out, int tabs = 0) const { toxml(out, tag_, tabs); }

protected:
	//  --  method
	virtual void print(ostream&) const;
	virtual void toxml(ostream&, const string&, int tabs) const;

	//  --  members:
	string tag_;
	int minLevel_;
	int maxLevel_;
	double outlayer_;

private:
  
	friend ostream& operator<<(ostream& s,const LookupTableModeAttributes& p)
	{ p.print(s); return s; }
};

} // namespace magics

#endif
